<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.util.*" %>
<%@ taglib prefix="sdk" uri="http://agillic.com/jsp/sdk/1.0" %>
<%@ taglib prefix="inp" uri="http://agillic.com/jsp/sdkinput/1.0" %>

<sdk:render>
    <!-- Basic text, you probably want something more advanced here :) -->
    Thank you for signing up
</sdk:render>

<sdk:action>
    <%
        //First we start by creating the user - we get the fields from the form came from our tags and were tied to a Person Data
        Map<String, String> map = flow.getEnteredClmAttributes();
        //Now we create a user based on this data - the returned value is the internal user id that we'll use from then on
        String userId = api.createBasePerson(map);

        /*
         * In this example I have a One-To-Many table called COLORS - this has three fields COLOR (which is primary key), a date when the color was selected and a date when it was removed (which I will only use in the update scenario)
          * What I do in the following is first to simply generated the selected day (i.e today) - then loop over the values entered in the form and create the relevant OTM lines
         */
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("dd.MM.yyyy"); //This is the default date format for api values - this should of course match what the system is configured to use
        String today = simpleDateFormat.format(new Date());
        //All the checkboxes had the same name which means that they will be represented as an array
        String[] colors = request.getParameterValues("color");
        List<Map<String, String>> oneToManyLines = new ArrayList<Map<String, String>>();
        //Null just to be sure to handle the case where the person didn't like any colors
        if (colors != null) {
            //We iterate over the colors and create each line
            for (String color : colors) {
                //Each line is a map that maps column names to values - in this case we store the color and the selected date
                Map<String, String> m = new HashMap<String, String>();
                m.put("COLOR", color);
                m.put("SELECTED_DATE", today);
                oneToManyLines.add(m);
            }
        }

        if (!oneToManyLines.isEmpty()) {
            //At least one color was chosen so now we add the lines to the user in the table called colors
            api.addMultipleOneToManyRecordForPerson(userId, "COLORS", oneToManyLines);
        }

        //Finally we achieve an event to signal that the user was created - of course the event should be created in the system for this to have any meaning
        api.achieveEvent(userId, "Signup", "web", "signup");
    %>
</sdk:action>


